ModuleInfo "Version: 1.04"
ModuleInfo "Author: Sophie Kirschner : meapineapple@gmail.com"
ModuleInfo "License: Creative Commons Attribution-ShareAlike 3.0 Unported (CC BY-SA 3.0)"
ModuleInfo "Modserver: pine"
ModuleInfo "History: 1.04 Release"
ModuleInfo "History: Rennamed BinNode.removevalue to BinNode.removeonevalue, changed behavior of BinNode.removevalue"
ModuleInfo "History: Added BinNode.containsvalue()"
ModuleInfo "History: Added TreeRemoveValue()"
ModuleInfo "History: 1.03 Release"
ModuleInfo "History: Added TreeFindCount"
ModuleInfo "History: 1.02 Release"
ModuleInfo "History: Added BinNodeValue"
ModuleInfo "History: 1.01 Release"
ModuleInfo "History: Added splay tree functionality"
ModuleInfo "History: changed BinTree.remove() to return a node instead of a boolean and added TreeRemoveFirst"
ModuleInfo "History: Revised handling of duplicate keys"
import brl.blitz
import brl.math
import brl.linkedlist
CreateTree:BinTree(splay%=1)="pine_bintree_CreateTree"
TreeSetSplay%(tree:BinTree,splay%)="pine_bintree_TreeSetSplay"
TreeGetSplay%(tree:BinTree)="pine_bintree_TreeGetSplay"
TreeRoot:BinNode(tree:BinTree)="pine_bintree_TreeRoot"
TreeSplayNode%(tree:BinTree,node:BinNode)="pine_bintree_TreeSplayNode"
ClearTree%(tree:BinTree)="pine_bintree_ClearTree"
CountTree%(tree:BinTree)="pine_bintree_CountTree"
CountTreeNodes%(tree:BinTree)="pine_bintree_CountTreeNodes"
TreeHeight%(tree:BinTree)="pine_bintree_TreeHeight"
TreeIsEmpty%(tree:BinTree)="pine_bintree_TreeIsEmpty"
TreeContains%(tree:BinTree,key$)="pine_bintree_TreeContains"
TreeInsert:BinNode(tree:BinTree,key$,value:Object)="pine_bintree_TreeInsert"
TreeRemove%(tree:BinTree,key$)="pine_bintree_TreeRemove"
TreeRemoveFirst:BinNode(tree:BinTree,key$)="pine_bintree_TreeRemoveFirst"
TreeRemoveNode%(tree:BinTree,node:BinNode)="pine_bintree_TreeRemoveNode"
TreeRemoveValue%(tree:BinTree,value:Object,key$=$"")="pine_bintree_TreeRemoveValue"
TreeFind:Object(tree:BinTree,key$)="pine_bintree_TreeFind"
TreeFindNode:BinNode(tree:BinTree,key$)="pine_bintree_TreeFindNode"
TreeFindAll:TList(tree:BinTree,key$)="pine_bintree_TreeFindAll"
TreeFindCount%(tree:BinTree,key$)="pine_bintree_TreeFindCount"
TreeToArray:Object&[](tree:BinTree,sort%=0)="pine_bintree_TreeToArray"
OptimizeTree%(tree:BinTree)="pine_bintree_OptimizeTree"
TreeObjects:BinEnum(tree:BinTree)="pine_bintree_TreeObjects"
TreeKeys:BinEnum(tree:BinTree)="pine_bintree_TreeKeys"
TreeNodes:BinEnum(tree:BinTree)="pine_bintree_TreeNodes"
CopyTree:BinTree(tree:BinTree)="pine_bintree_CopyTree"
BinNodeString$(node:BinNode)="pine_bintree_BinNodeString"
BinNodeContents:TList(node:BinNode)="pine_bintree_BinNodeContents"
BinNodeKey$(node:BinNode)="pine_bintree_BinNodeKey"
BinNodeValue:Object(node:BinNode)="pine_bintree_BinNodeValue"
BinNodeData^Object{
.nxt:BinNodeData&
.data:Object&
-New%()="_pine_bintree_BinNodeData_New"
-Delete%()="_pine_bintree_BinNodeData_Delete"
+Create:BinNodeData(o:Object)="_pine_bintree_BinNodeData_Create"
-copy:BinNodeData()="_pine_bintree_BinNodeData_copy"
-csv$()="_pine_bintree_BinNodeData_csv"
}="pine_bintree_BinNodeData"
BinNode^Object{
.key$&
.data:BinNodeData&
.parent:BinNode&
.l:BinNode&
.r:BinNode&
-New%()="_pine_bintree_BinNode_New"
-Delete%()="_pine_bintree_BinNode_Delete"
-csv$()="_pine_bintree_BinNode_csv"
-leftmostchild:BinNode()="_pine_bintree_BinNode_leftmostchild"
-rightmostchild:BinNode()="_pine_bintree_BinNode_rightmostchild"
-movetoright%(t:BinNode)="_pine_bintree_BinNode_movetoright"
-movetoleft%(t:BinNode)="_pine_bintree_BinNode_movetoleft"
-orphan%()="_pine_bintree_BinNode_orphan"
-remove:BinNode()="_pine_bintree_BinNode_remove"
-removevalue:BinNode(value:Object,flag%=1)="_pine_bintree_BinNode_removevalue"
-removeonevalue:BinNode(flag%=1)="_pine_bintree_BinNode_removeonevalue"
-removeallvalues:BinNode(flag%=0)="_pine_bintree_BinNode_removeallvalues"
-value:Object()="_pine_bintree_BinNode_value"
-values:TList()="_pine_bintree_BinNode_values"
-containsvalue%(val:Object)="_pine_bintree_BinNode_containsvalue"
-valuecount%()="_pine_bintree_BinNode_valuecount"
-insert:BinNode(n:BinNode)="_pine_bintree_BinNode_insert"
-addvalue%(n:BinNodeData)="_pine_bintree_BinNode_addvalue"
-findclosest:BinNode(k$)="_pine_bintree_BinNode_findclosest"
-count%()="_pine_bintree_BinNode_count"
-countvalues%()="_pine_bintree_BinNode_countvalues"
-height%()="_pine_bintree_BinNode_height"
-clearlinks%()="_pine_bintree_BinNode_clearlinks"
-optimize:BinNode()="_pine_bintree_BinNode_optimize"
+optimize_:BinNode(start%,fin%,array:BinNode&[])="_pine_bintree_BinNode_optimize_"
-nodesinorder:BinNode&[]()="_pine_bintree_BinNode_nodesinorder"
-nodesinorder_%(index% Var,array:BinNode&[])="_pine_bintree_BinNode_nodesinorder_"
-nodesreverseorder:BinNode&[]()="_pine_bintree_BinNode_nodesreverseorder"
-nodesreverseorder_%(index% Var,array:BinNode&[])="_pine_bintree_BinNode_nodesreverseorder_"
-nodespreorder:BinNode&[]()="_pine_bintree_BinNode_nodespreorder"
-nodespreorder_%(index% Var,array:BinNode&[])="_pine_bintree_BinNode_nodespreorder_"
-nodespostorder:BinNode&[]()="_pine_bintree_BinNode_nodespostorder"
-nodespostorder_%(index% Var,array:BinNode&[])="_pine_bintree_BinNode_nodespostorder_"
-inorder:Object&[]()="_pine_bintree_BinNode_inorder"
-inorder_%(index% Var,array:Object&[])="_pine_bintree_BinNode_inorder_"
-reverseorder:Object&[]()="_pine_bintree_BinNode_reverseorder"
-reverseorder_%(index% Var,array:Object&[])="_pine_bintree_BinNode_reverseorder_"
-preorder:Object&[]()="_pine_bintree_BinNode_preorder"
-preorder_%(index% Var,array:Object&[])="_pine_bintree_BinNode_preorder_"
-postorder:Object&[]()="_pine_bintree_BinNode_postorder"
-postorder_%(index% Var,array:Object&[])="_pine_bintree_BinNode_postorder_"
+Create:BinNode(key$,o:Object)="_pine_bintree_BinNode_Create"
-successor:BinNode()="_pine_bintree_BinNode_successor"
-predecessor:BinNode()="_pine_bintree_BinNode_predecessor"
-copy:BinNode()="_pine_bintree_BinNode_copy"
}="pine_bintree_BinNode"
BinTree^Object{
.root:BinNode&
.autosplay%&
-New%()="_pine_bintree_BinTree_New"
-Delete%()="_pine_bintree_BinTree_Delete"
-isempty%()="_pine_bintree_BinTree_isempty"
-issplay%()="_pine_bintree_BinTree_issplay"
-setsplay%(dosplay%)="_pine_bintree_BinTree_setsplay"
-copy:BinTree()="_pine_bintree_BinTree_copy"
-insert:BinNode(key$,o:Object="bbNullObject",dosplay%=-1)="_pine_bintree_BinTree_insert"
-findclosestnode:BinNode(key$,dosplay%=-1)="_pine_bintree_BinTree_findclosestnode"
-findnode:BinNode(key$,dosplay%=-1)="_pine_bintree_BinTree_findnode"
-findclosest:Object(key$,dosplay%=-1)="_pine_bintree_BinTree_findclosest"
-contains%(key$,dosplay%=0)="_pine_bintree_BinTree_contains"
-find:Object(key$,dosplay%=-1)="_pine_bintree_BinTree_find"
-findall:TList(key$,dosplay%=-1)="_pine_bintree_BinTree_findall"
-findcount%(key$,dosplay%=-1)="_pine_bintree_BinTree_findcount"
-remove:BinNode(key$)="_pine_bintree_BinTree_remove"
-removeall:BinNode(key$)="_pine_bintree_BinTree_removeall"
-removenode:BinNode(n:BinNode)="_pine_bintree_BinTree_removenode"
-removevalue%(value:Object,key$=$"")="_pine_bintree_BinTree_removevalue"
-count%()="_pine_bintree_BinTree_count"
-countvalues%()="_pine_bintree_BinTree_countvalues"
-height%()="_pine_bintree_BinTree_height"
-clear%()="_pine_bintree_BinTree_clear"
-optimize%()="_pine_bintree_BinTree_optimize"
-toarray:Object&[](sort%=0)="_pine_bintree_BinTree_toarray"
+Create:BinTree(splay%=1)="_pine_bintree_BinTree_Create"
-ObjectEnumerator:BinEnum()="_pine_bintree_BinTree_ObjectEnumerator"
-KeyEnumerator:BinEnum()="_pine_bintree_BinTree_KeyEnumerator"
-NodeEnumerator:BinEnum()="_pine_bintree_BinTree_NodeEnumerator"
-splay%(n:BinNode)="_pine_bintree_BinTree_splay"
-rotright%(n:BinNode)="_pine_bintree_BinTree_rotright"
-rotleft%(n:BinNode)="_pine_bintree_BinTree_rotleft"
}="pine_bintree_BinTree"
BinEnum^Object{
.node:BinNode&
.data:BinNodeData&
.kind%&
-New%()="_pine_bintree_BinEnum_New"
-Delete%()="_pine_bintree_BinEnum_Delete"
+Create:BinEnum(n:BinNode,kind%=0)="_pine_bintree_BinEnum_Create"
-HasNext%()="_pine_bintree_BinEnum_HasNext"
-NextObject:Object()="_pine_bintree_BinEnum_NextObject"
-ObjectEnumerator:BinEnum()="_pine_bintree_BinEnum_ObjectEnumerator"
}="pine_bintree_BinEnum"
