SuperStrict

'import required modules
Framework brl.standardio
Import pine.HashTable

'create a new hash table object of size 32
Local hash:HashTable=CreateHash(32)

'put some stuff in it
HashInsert hash,"bear","panda"
HashInsert hash,"bear","grizzly"
HashInsert hash,"bear","black"
HashInsert hash,"bird","chickadee"
HashInsert hash,"bird","robin"
HashInsert hash,"rock","n roll"
HashInsert hash,"rock","granite"
HashInsert hash,"rock","hematite"

'go through and print it all
Print "Contents:"
For Local node:HashNode=EachIn HashNodes(hash)
	Print HashNodeKey(node)+" : "+String(HashNodeValue(node))
Next

'now take some of them out
Print "Removing all the birds..."
HashRemoveAll hash,"bird"

'go through and print what's left
Print "Contents:"
For Local node:HashNode=EachIn HashNodes(hash)
	Print HashNodeKey(node)+" : "+String(HashNodeValue(node))
Next

'now take more of them out
Print "Removing all the bears..."
HashRemoveAll hash,"bear"

'and go through and print what's left one more time
Print "Contents:"
For Local node:HashNode=EachIn HashNodes(hash)
	Print HashNodeKey(node)+" : "+String(HashNodeValue(node))
Next
