SuperStrict

'import required modules
Framework brl.standardio
Import brl.random
Import pine.BinTree

'create a new tree object
Local tree:bintree=CreateTree()

'fill the tree with a random amount of elements
SeedRnd MilliSecs()
For Local i%=1 To Rand(20,50)
	TreeInsert tree,i,String(i)
Next

'print out the contents of the tree
'note that keys are compared as strings, not numbers, so that the list is not ordered numerically.
Print "Tree contents:"
For Local str$=EachIn tree
	Print str
Next

'print the number of elements in the tree
Print "Number of elements: "+CountTree(tree)