SuperStrict

'import required modules
Framework brl.standardio
Import pine.BinTree

'create a new tree object
Local tree:BinTree=CreateTree()

'fill the tree with the letters a-g
For Local i%=Asc("a") To Asc("g")
	TreeInsert tree,Chr(i),String(i)
Next

'balance the tree
OptimizeTree tree

'print out all the keys in the tree
Print "Keys:"
For Local str$=EachIn TreeKeys(tree)
	Print str
Next
'print out all the objects in the tree
Print "Values:"
For Local str$=EachIn TreeObjects(tree)
	Print str
Next
'print out all the keys and value pairs in the tree
Print "Keys:"
For Local n:BinNode=EachIn TreeNodes(tree)
	Print n.key+","+String(n.data)
Next