SuperStrict

'import required modules
Framework brl.standardio
Import pine.BinTree

'create a new tree object
Local tree:BinTree=CreateTree()

'fill the tree with the letters a-g
For Local i%=Asc("a") To Asc("g")
	TreeInsert tree,Chr(i),Chr(i)
Next

'balance the tree
OptimizeTree tree

'print out the contents of the tree, iterating left-to-right
Print "EachIn:"
For Local str$=EachIn tree
	Print str
Next

'print out the contents of the tree in-order
Print "In-order:"
For Local str$=EachIn TreeToArray(tree,0)
	Print str
Next

'print out the contents of the tree reversed in-order
Print "Reverse-order:"
For Local str$=EachIn TreeToArray(tree,1)
	Print str
Next

'print out the contents of the tree pre-order
Print "Pre-order:"
For Local str$=EachIn TreeToArray(tree,2)
	Print str
Next

'print out the contents of the tree post-order
Print "Post-order:"
For Local str$=EachIn TreeToArray(tree,3)
	Print str
Next